using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using System.Data;
using ZXDT.DBUtility;

namespace ZXDT.CallCenter.DAL
{
    /// <summary>
    /// 数据访问类:T_Ask_QuestionItems
    /// </summary>
    public partial class T_Ask_QuestionItems
    {
        public T_Ask_QuestionItems()
        { }
        #region  Method
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_ItemId)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Ask_QuestionItems");
            strSql.Append(" where F_ItemId=@F_ItemId");
            SqlParameter[] parameters = {
					new SqlParameter("@F_ItemId", SqlDbType.Int,4)
			};
            parameters[0].Value = F_ItemId;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(ZXDT.CallCenter.Model.T_Ask_QuestionItems model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Ask_QuestionItems(");
            strSql.Append("F_QuestionId,F_ItemName,F_IsAnswer,F_Remark,F_Sort,F_SortModel)");
            strSql.Append(" values (");
            strSql.Append("@F_QuestionId,@F_ItemName,@F_IsAnswer,@F_Remark,@F_Sort,@F_SortModel)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
					new SqlParameter("@F_QuestionId", SqlDbType.Int,4),
					new SqlParameter("@F_ItemName", SqlDbType.VarChar,50),
					new SqlParameter("@F_IsAnswer", SqlDbType.SmallInt,2),
					new SqlParameter("@F_Remark", SqlDbType.VarChar,200),
					new SqlParameter("@F_Sort", SqlDbType.Int,4),
					new SqlParameter("@F_SortModel", SqlDbType.SmallInt,2)};
            parameters[0].Value = model.F_QuestionId;
            parameters[1].Value = model.F_ItemName;
            parameters[2].Value = model.F_IsAnswer;
            parameters[3].Value = model.F_Remark;
            parameters[4].Value = model.F_Sort;
            parameters[5].Value = model.F_SortModel;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(ZXDT.CallCenter.Model.T_Ask_QuestionItems model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Ask_QuestionItems set ");
            strSql.Append("F_QuestionId=@F_QuestionId,");
            strSql.Append("F_ItemName=@F_ItemName,");
            strSql.Append("F_IsAnswer=@F_IsAnswer,");
            strSql.Append("F_Remark=@F_Remark,");
            strSql.Append("F_Sort=@F_Sort,");
            strSql.Append("F_SortModel=@F_SortModel");
            strSql.Append(" where F_ItemId=@F_ItemId");
            SqlParameter[] parameters = {
					new SqlParameter("@F_QuestionId", SqlDbType.Int,4),
					new SqlParameter("@F_ItemName", SqlDbType.VarChar,50),
					new SqlParameter("@F_IsAnswer", SqlDbType.SmallInt,2),
					new SqlParameter("@F_Remark", SqlDbType.VarChar,200),
					new SqlParameter("@F_Sort", SqlDbType.Int,4),
					new SqlParameter("@F_SortModel", SqlDbType.SmallInt,2),
					new SqlParameter("@F_ItemId", SqlDbType.Int,4)};
            parameters[0].Value = model.F_QuestionId;
            parameters[1].Value = model.F_ItemName;
            parameters[2].Value = model.F_IsAnswer;
            parameters[3].Value = model.F_Remark;
            parameters[4].Value = model.F_Sort;
            parameters[5].Value = model.F_SortModel;
            parameters[6].Value = model.F_ItemId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_ItemId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Ask_QuestionItems ");
            strSql.Append(" where F_ItemId=@F_ItemId");
            SqlParameter[] parameters = {
					new SqlParameter("@F_ItemId", SqlDbType.Int,4)
			};
            parameters[0].Value = F_ItemId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool DeleteByQuestionId(int F_QuestionId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Ask_QuestionItems ");
            strSql.Append(" where F_QuestionId=@F_QuestionId");
            SqlParameter[] parameters = {
					new SqlParameter("@F_QuestionId", SqlDbType.Int,4)
			};
            parameters[0].Value = F_QuestionId;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_ItemIdlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Ask_QuestionItems ");
            strSql.Append(" where F_ItemId in (" + F_ItemIdlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public ZXDT.CallCenter.Model.T_Ask_QuestionItems GetModel(int F_ItemId)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_ItemId,F_QuestionId,F_ItemName,F_IsAnswer,F_Remark,F_Sort,F_SortModel from T_Ask_QuestionItems ");
            strSql.Append(" where F_ItemId=@F_ItemId");
            SqlParameter[] parameters = {
					new SqlParameter("@F_ItemId", SqlDbType.Int,4)
			};
            parameters[0].Value = F_ItemId;

            ZXDT.CallCenter.Model.T_Ask_QuestionItems model = new ZXDT.CallCenter.Model.T_Ask_QuestionItems();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                if (ds.Tables[0].Rows[0]["F_ItemId"] != null && ds.Tables[0].Rows[0]["F_ItemId"].ToString() != "")
                {
                    model.F_ItemId = int.Parse(ds.Tables[0].Rows[0]["F_ItemId"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_QuestionId"] != null && ds.Tables[0].Rows[0]["F_QuestionId"].ToString() != "")
                {
                    model.F_QuestionId = int.Parse(ds.Tables[0].Rows[0]["F_QuestionId"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_ItemName"] != null && ds.Tables[0].Rows[0]["F_ItemName"].ToString() != "")
                {
                    model.F_ItemName = ds.Tables[0].Rows[0]["F_ItemName"].ToString();
                }
                if (ds.Tables[0].Rows[0]["F_IsAnswer"] != null && ds.Tables[0].Rows[0]["F_IsAnswer"].ToString() != "")
                {
                    model.F_IsAnswer = int.Parse(ds.Tables[0].Rows[0]["F_IsAnswer"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_Remark"] != null && ds.Tables[0].Rows[0]["F_Remark"].ToString() != "")
                {
                    model.F_Remark = ds.Tables[0].Rows[0]["F_Remark"].ToString();
                }
                if (ds.Tables[0].Rows[0]["F_Sort"] != null && ds.Tables[0].Rows[0]["F_Sort"].ToString() != "")
                {
                    model.F_Sort = int.Parse(ds.Tables[0].Rows[0]["F_Sort"].ToString());
                }
                if (ds.Tables[0].Rows[0]["F_SortModel"] != null && ds.Tables[0].Rows[0]["F_SortModel"].ToString() != "")
                {
                    model.F_SortModel = int.Parse(ds.Tables[0].Rows[0]["F_SortModel"].ToString());
                }
                return model;
            }
            else
            {
                return null;
            }
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_ItemId,F_QuestionId,F_ItemName,F_IsAnswer,F_Remark,F_Sort,F_SortModel ");
            strSql.Append(" FROM T_Ask_QuestionItems ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_ItemId,F_QuestionId,F_ItemName,F_IsAnswer,F_Remark,F_Sort,F_SortModel ");
            strSql.Append(" FROM T_Ask_QuestionItems ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Ask_QuestionItems ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_ItemId desc");
            }
            strSql.Append(")AS Row, T.*  from T_Ask_QuestionItems T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetList(int PageSize,int PageIndex,string strWhere)
        {
            SqlParameter[] parameters = {
                    new SqlParameter("@tblName", SqlDbType.VarChar, 255),
                    new SqlParameter("@fldName", SqlDbType.VarChar, 255),
                    new SqlParameter("@PageSize", SqlDbType.Int),
                    new SqlParameter("@PageIndex", SqlDbType.Int),
                    new SqlParameter("@IsReCount", SqlDbType.Bit),
                    new SqlParameter("@OrderType", SqlDbType.Bit),
                    new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
                    };
            parameters[0].Value = "T_Ask_QuestionItems";
            parameters[1].Value = "F_ItemId";
            parameters[2].Value = PageSize;
            parameters[3].Value = PageIndex;
            parameters[4].Value = 0;
            parameters[5].Value = 0;
            parameters[6].Value = strWhere;	
            return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
        }*/

        #endregion  Method
    }
}

